OGRE: Ogre::DefaultHardwareBufferManagerBase Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::DefaultHardwareBufferManagerBase Class Reference
Core » RenderSystem

Specialisation of HardwareBufferManagerBase to emulate hardware buffers. More...

`#include <OgreDefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::DefaultHardwareBufferManagerBase:
[legend]

## Public Member Functions
| DefaultHardwareBufferManagerBase ()
| ~DefaultHardwareBufferManagerBase ()
HardwareIndexBufferPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false) override
| Create a hardware index buffer.
HardwareBufferPtr | createUniformBuffer (size_t sizeBytes, HardwareBufferUsage=HBU_CPU_ONLY, bool=false) override
| Create uniform buffer.
HardwareVertexBufferPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false) override
| Create a hardware vertex buffer.
Public Member Functions inherited from Ogre::HardwareBufferManagerBase
| HardwareBufferManagerBase ()
virtual | ~HardwareBufferManagerBase ()
void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers; is called by OGRE.
HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual RenderToVertexBufferSharedPtr | createRenderToVertexBuffer ()
| Create a render to vertex buffer.
VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding.
VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration.
void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.

## Detailed Description

Specialisation of HardwareBufferManagerBase to emulate hardware buffers.

You might want to instantiate this class if you want to utilise classes like MeshSerializer without having initialised the rendering system (which is required to create a 'real' hardware buffer manager).

## Constructor & Destructor Documentation

## ◆ DefaultHardwareBufferManagerBase()

Ogre::DefaultHardwareBufferManagerBase::DefaultHardwareBufferManagerBase | ( |  | ) |

## ◆ ~DefaultHardwareBufferManagerBase()

Ogre::DefaultHardwareBufferManagerBase::~DefaultHardwareBufferManagerBase | ( |  | ) |

## Member Function Documentation

## ◆ createVertexBuffer()

HardwareVertexBufferPtr Ogre::DefaultHardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false )
| overridevirtual

Create a hardware vertex buffer.

This method creates a new vertex buffer; this will act as a source of geometry data for rendering objects. Note that because the meaning of the contents of the vertex buffer depends on the usage, this method does not specify a vertex format; the user of this buffer can actually insert whatever data they wish, in any format. However, in order to use this with a RenderOperation, the data in this vertex buffer will have to be associated with a semantic element of the rendering pipeline, e.g. a position, or texture coordinates. This is done using the VertexDeclaration class, which itself contains VertexElement structures referring to the source data. Note that because vertex buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  vertexSize | The size in bytes of each vertex in this buffer; you must calculate this based on the kind of data you expect to populate this buffer with.
  numVerts | The number of vertices in this buffer.
  usage | One or more members of the HardwareBufferUsage enumeration; you are strongly advised to use HBU_GPU_ONLY wherever possible, if you need to update regularly, consider HBU_CPU_TO_GPU or useShadowBuffer=true.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU memory. See Shadow Buffers.

Implements Ogre::HardwareBufferManagerBase.

## ◆ createIndexBuffer()

HardwareIndexBufferPtr Ogre::DefaultHardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false )
| overridevirtual

Create a hardware index buffer.

Remarks
  Note that because buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  itype | The type in index, either 16- or 32-bit, depending on how many vertices you need to be able to address
  numIndexes | The number of indexes in the buffer
  usage | One or more members of the HardwareBufferUsage enumeration.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU memory. See Shadow Buffers.

Implements Ogre::HardwareBufferManagerBase.

## ◆ createUniformBuffer()

HardwareBufferPtr Ogre::DefaultHardwareBufferManagerBase::createUniformBuffer | ( | size_t | sizeBytes,
|  | HardwareBufferUsage | usage = HBU_CPU_ONLY,
|  | bool | useShadowBuffer = false )
| inlineoverridevirtual

Create uniform buffer.

This type of buffer allows the upload of shader constants once, and sharing between shader stages or even shaders from another materials. The update shall be triggered by GpuProgramParameters, if is dirty

Reimplemented from Ogre::HardwareBufferManagerBase.

References Ogre::HBU_CPU_ONLY.

The documentation for this class was generated from the following file:

- OgreDefaultHardwareBufferManager.h